import refreshTokenHelper from "../../../../../utils/refreshTokenHelper"
import forceLogoutHelper from "../../../../../utils/forceLogoutHelper"
import errorHandlingHelper from "../../../../../utils/errorHandlingHelper"
import fetchHelper from "../../../../../utils/fetchHelper"

const handleFunc = async (event: any, authToken: any = null) => {
  let data: any = {}
  const token = authToken ?? await getTokenHelper(event)
  const body = await readBody(event)

  let newObjValue = {}
  if(body.operationId) {
    newObjValue = {...newObjValue, Operation: {
      id: body.operationId
    }}
  }
  if(body.distributionTypeId) {
    newObjValue = {...newObjValue, DistributionType: {
      id: body.distributionTypeId
    }}
  }
  if(body.distributionSortingId) {
    newObjValue = {...newObjValue, DistributionSorting: {
      id: body.distributionSortingId
    }}
  }
  if(body.promotionLineId) {
    newObjValue = {...newObjValue, M_PromotionLine_ID: {
      id: body.promotionLineId,
      tableName: 'M_PromotionLine'
    }}
  }

  if(body.id) {
    const res: any = await fetchHelper(event, 'models/m_promotiondistribution/'+body.id, 'PUT', token, {
      isActive: body.isActive,
      seqNo: body.seqNo,
      qty: body.qty,
      ...newObjValue,
      tableName: 'm_promotiondistribution'
    })
    if(res) {
      data = res
      data['status'] = 200
      data['message'] = ''
    }
  }

  return data
}

export default defineEventHandler(async (event) => {
  let data: any = {}

  try {
    data = await handleFunc(event)
  } catch(err: any) {
    try {
      let authToken: any = await refreshTokenHelper(event)
      data = await handleFunc(event, authToken)
    } catch(error: any) {
      data = errorHandlingHelper(err?.data ?? err, error?.data ?? error)
      forceLogoutHelper(event, data)
    }
  }

  return data
})